<template>
  <div v-if="loading" class="loader"></div>
  <template v-else>
    <div class="captcha">
      <captcha :value="captcha" @isValid="getErrorMessage" width="220" />
      <el-input
        class="my-2.5 captcha"
        type="text"
        :model-value="captcha"
        @input="$emit('update:captcha', $event)"
        :placeholder="$t('enter_validation_code')"
      />
    </div>
    <button
      id="btn-submit-captcha"
      :disabled="isInvalid || captcha.length != 5"
      @click="$emit('update:dialogVisible', false)"
    >
      {{ $t("ok") }}
    </button>
  </template>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref } from "vue";

export default defineComponent({
  props: {
    captcha: {
      type: String,
      default: "",
    },
    getErrorMessage: {
      type: Function,
      default: () => "",
    },
    isInvalid: {
      type: Boolean,
      default: true,
    },
  },
  emits: ["update:captcha", "update:dialogVisible"],
  setup() {
    const loading = ref(true);
    onMounted(() => {
      setTimeout(() => {
        loading.value = false;
      }, 3250);
    });
    return {
      loading,
    };
  },
});
</script>

<style lang="scss">
:root {
  --captcha-button-color: rgba(108 123 168 / 0.5);
  --captcha-loading-color: var(--selected, var(--primary));
  --captcha-submit-button-color: var(--selected, var(--primary));
  --captcha-submit-button-text-color: #fff;
  --captcha-dialog-border-top-color: var(--selected, var(--primary));
}

.btn-click-captcha-to-verify {
  .is-error {
    #captcha-button {
      box-shadow: 0 0 0 1px var(--failure) inset;
    }
  }
}
#captcha-button {
  width: 100%;
  height: 32px;
  border-radius: 3px;
  display: flex;
  background-color: var(--captcha-button-color);
  align-items: center;
  justify-content: center;
  cursor: pointer;
  position: relative;
  padding-left: 0.25rem;
  padding-right: 0.25rem;
}

#captcha-pop-up-verify {
  cursor: pointer;
  display: flex;
  justify-content: center;
  align-items: center;
  border: unset;
  background: transparent;
  color: #fff;
  margin: 0;
  gap: 0.25rem;
  text-overflow: ellipsis;
}
.captcha-dialog-container {
  .loader,
  .loader::before,
  .loader::after {
    background: var(--captcha-loading-color);
    animation: loading 1s infinite ease-in-out;
    width: 1em;
    height: 4em;
  }
  .loader {
    color: var(--captcha-loading-color);
    text-indent: -9999em;
    margin: 60px auto;
    position: relative;
    font-size: 11px;
    transform: translateZ(0);
    animation-delay: -0.16s;

    &::after,
    &::before {
      position: absolute;
      top: 0;
      content: "";
    }

    &::after {
      left: 1.5em;
    }

    &::before {
      left: -1.5em;
      animation-delay: -0.32s;
    }
  }
  @keyframes loading {
    0%,
    80%,
    100% {
      box-shadow: 0 0;
      height: 4em;
    }
    40% {
      box-shadow: 0 -2em;
      height: 5em;
    }
  }
  .captcha-dialog {
    border-top: 5px solid var(--captcha-dialog-border-top-color);

    & .el-form-item {
      margin-bottom: 10px;
    }
  }
  .el-dialog {
    height: 210px;
  }
  .el-dialog:focus-visible {
    outline: unset;
  }
  .el-dialog__header {
    padding: unset;
  }
  #btn-submit-captcha {
    text-transform: uppercase;
    outline: none;
    width: 100%;
    text-align: center;
    background: var(--captcha-submit-button-color);
    border: unset;
    color: var(--captcha-submit-button-text-color);
    border-radius: 5px;
    height: 32px;
    margin-top: 10px;
    &:disabled {
      opacity: 0.5;
    }
  }
  .el-dialog__body {
    padding: unset;
  }
}
  [theme-color=main_lightblue][data-device=desktop] .el-input.captcha {
    --el-text-color-regular: var(--text);
  }
</style>
